unit u_c_person_properties;
  interface
    uses u_c_databinder_5;

    type c_person= // one "person"
             Class(c_origin_object)
               m_name: String;
               m_age: integer;
               m_salary: Double;

               Constructor create_person(p_name: String;
                   p_age: integer; p_salary: Double);
               function f_c_self: c_person;

               function f_display_person: String;

               Destructor Destroy; Override;

               Property Name: String Read m_name Write m_name;
               Property Age: Integer Read m_age Write m_age;
               Property Salary: Double Read m_salary Write m_salary;
             end; // c_person

  implementation
    uses SysUtils, u_display_simple;

    // -- c_person

    Constructor c_person.create_person(p_name: String;
        p_age: integer; p_salary: Double);
      begin
        Inherited create;
        m_name:= p_name;
        m_age:= p_age;
        m_salary:= p_salary;
      end; // create_person

    function c_person.f_display_person: String;
      begin
        Result:= Format('%-10s %2d %7.2f', [m_name, m_age, m_salary]);
      end; // f_display_person

    function c_person.f_c_self: c_person;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_person.Destroy;
      begin
        InHerited;
      end; // Destroy

end.
