unit u_c_person_properties_5;
  interface
    uses u_c_rtti_databinder_5;

    type c_person= // one "person"
             Class(c_origin_object)
               m_name: String;
               m_age: integer;

               Constructor create_person(p_name: String;
                   p_age: integer);
               function f_c_self: c_person;

               function f_display_person: String;

               procedure set_name(p_name: String);
               procedure set_age(p_age: Integer);

               Destructor Destroy; Override;

               Property Name: String Read m_name Write m_name;
               Property Age: Integer Read m_age Write set_age;
             end; // c_person

  implementation
    uses SysUtils, u_display_simple;

    // -- c_person

    Constructor c_person.create_person(p_name: String; p_age: integer);
      begin
        Inherited create;
        m_name:= p_name;
        m_age:= p_age;
      end; // create_person

    function c_person.f_display_person: String;
      begin
        Result:= Format('%-10s %2d', [m_name, m_age]);
      end; // f_display_person

    function c_person.f_c_self: c_person;
      begin
        Result:= Self;
      end; // f_c_self

    procedure c_person.set_name(p_name: String);
      begin
        m_name:= p_name;
        update_target_values
      end; // set_name

    procedure c_person.set_age(p_age: Integer);
      begin
        m_age:= p_age;
        update_target_values
      end; // set_age

    Destructor c_person.Destroy;
      begin
        InHerited;
      end; // Destroy

end.
