// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_rtti_databinder_5;
  interface
    uses Classes, Generics.Collections, Generics.Defaults
        , Controls;

    type c_origin_object= Class; // forward

         c_binding_info=
             class
               m_c_origin_object: c_origin_object;
               m_origin_property_name: String;
               m_c_target_object: tObject;
               m_target_property_name: String;

               constructor Create(
                   p_c_origin_object: c_origin_object;
                   p_origin_property_name: String;
                   p_c_target_object: tObject;
                   p_target_property_name: String);

               function f_bind_info: String;
             end; // c_binding_info

         c_origin_object=
             class(tObject)
                 m_c_binding_info_list: TList<c_binding_info> ;

                 constructor Create;
                 procedure add_target_object(
                     p_c_origin_object: c_origin_object; p_origin_property_name: String;
                     p_c_target_object: tObject; AControlProperty: String);
                 procedure update_target_values;
                 destructor Destroy; override;
             end; // c_origin_object

  implementation
      uses SysUtils, Rtti, u_display_simple;

    // -- c_binding_info

    constructor c_binding_info.Create(
        p_c_origin_object: c_origin_object; p_origin_property_name: String;
        p_c_target_object: tObject; p_target_property_name: String);
      begin
        inherited Create;

        m_c_target_object:= p_c_target_object;
        m_target_property_name:= p_target_property_name;
        m_c_origin_object:= p_c_origin_object;
        m_origin_property_name:= p_origin_property_name;
      end; // Create

    function c_binding_info.f_bind_info: String;
      begin
        Result:=
            m_c_origin_object.ClassName+ '.'+ m_origin_property_name
            + '->'
            // + Control.Name+ '.'+ ControlPropertyName;
      end; // f_bind_info

    // -- c_origin_object

    constructor c_origin_object.Create;
      begin
        inherited;

        m_c_binding_info_list:= TList<c_binding_info>.Create;
      end; // Create

    procedure c_origin_object.add_target_object(
        p_c_origin_object: c_origin_object; p_origin_property_name: String;
        p_c_target_object: tObject; AControlProperty: String);
      begin
        m_c_binding_info_list.Add(
            c_binding_info.Create(
                Self, p_origin_property_name,
                p_c_target_object, AControlProperty));
      end; // add_target_object

    procedure c_origin_object.update_target_values;
        // -- c_person.m_name -> tNameEdit.Text
      var l_rtti_context: tRttiContext;
          l_c_origin_object_rtti_type: tRttiType;
          l_c_origin_object_rtti_property: tRttiProperty;
          l_c_binding_info: c_binding_info;

          l_c_target_object: tObject;
          l_c_target_object_rtti_type: tRttiType;
          l_c_target_object_rtti_property: tRttiProperty;

          l_origin_tvalue: tValue;
      begin
        l_rtti_context:= tRttiContext.Create;
        // -- scan the origin for the origin property names
        l_c_origin_object_rtti_type:= l_rtti_context.GetType(Self.ClassType);
        if l_c_origin_object_rtti_type= Nil
          then begin
              display('Nil');
              Exit;
          end;

        for l_c_origin_object_rtti_property in l_c_origin_object_rtti_type.GetProperties do
        begin
          display(l_c_origin_object_rtti_property.ToString);
          for l_c_binding_info in m_c_binding_info_list do
            if SameText(l_c_binding_info.m_origin_property_name, l_c_origin_object_rtti_property.Name)
              then begin
                  display('  same '+ l_c_binding_info.m_origin_property_name);
                  l_c_target_object:= l_c_binding_info.m_c_target_object;
                  l_c_target_object_rtti_type:= l_rtti_context.GetType(l_c_target_object.ClassType);
                  l_origin_tvalue:= l_c_origin_object_rtti_property.GetValue(Self);

                  for l_c_target_object_rtti_property in l_c_target_object_rtti_type.GetProperties do
                    if SameText(l_c_binding_info.m_target_property_name, l_c_target_object_rtti_property.Name)
                      then begin
                          display('    same '+ l_c_binding_info.m_target_property_name);
                          l_c_target_object_rtti_property.SetValue(l_c_target_object, l_origin_tvalue);
                        end;
                end;
        end; // for l_c_origin_object_rtti_property
        l_rtti_context.Free;
      end; // update_target_values

    destructor c_origin_object.Destroy;
      begin
        m_c_binding_info_list.Free;
        inherited;
      end; // Destroy


end.

